# Robot

# DATI
param n;		# N. di robot
set R := 1..n;	# Insieme indicizzato dei robot
param r {R};	# Raggio d'azione di ogni robot [cm]

# VARIABILI
# Posizioni dei robot [cm]
var x {R};		# Ascisse
var y {R};		# Ordinate
var d {i in R,j in R: i<j};	# Distanza euclidea [cm]

# VINCOLI
subject to No_overlap {i in R, j in R: i<j}:
   d[i,j] >= r[i] + r[j];

subject to Distanze {i in R, j in R: i<j}:
  d[i,j]^2 = (x[i]-x[j])^2 + (y[i]-y[j])^2;
  
# OBIETTIVO
minimize z: sum {i in R, j in R: i<j} d[i,j];

##################################
data;
param n := 6;
param r :=
1 120
2  80
3 100
4  70
5  45
6 120;

var: x   y :=
1      0     0
2   1000  1000
3  -1000 -1000
4      0  1000
5   1000     0
6   2000  2000;

end;
